diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/cook.c tin-2.6.5/src/cook.c
--- tin-2.6.4/src/cook.c	2024-12-04 18:12:24.000000000 +0100
+++ tin-2.6.5/src/cook.c	2025-12-13 09:50:24.183556469 +0100
@@ -986,102 +1293,391 @@ process_text_body_part(
 			break;	/* premature end of file, file error etc. */
 		}
 
-		process_charsets(&line, &max_line_len, charset, tinrc.mm_local_charset, curr_group->attribute->tex2iso_conv && art->tex2iso);
-
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-		if (IS_LOCAL_CHARSET("UTF-8")) {
-			utf8_valid(line);
-
-			if (!in_verbatim && curr_group->attribute->suppress_soft_hyphens && !strcasecmp(charset, "UTF-8"))
-				remove_soft_hyphens(line);
-		}
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+		/*
+		 * former is_art_tex_encoded(), may have false positives.
+		 * unfortinatly we decode on the fly, so we can't validate
+		 * via e.g. non blank lines vs. umlaut lines ratio (like
+		 * 20:1; typical in german is ~4:1 with lines around 70 chars).
+		 */
+		if (!art->tex2iso && (section == TEXT_SECTION || section == SIGNATURE_SECTION) && MATCH_REGEX(latex_regex, line, strlen(line)))
+			art->tex2iso = TRUE;
 
+		FreeAndNull(raw_line);
+		raw_line = my_strdup(line); /* we need the raw data for yenc decoding */
+		process_charsets(&line, &max_line_len, charset, tinrc.mm_local_charset, curr_group->attribute->tex2iso_conv && art->tex2iso && !(section & (VERBATIM_SECTION | VERBATIM_BEGIN)));
 		len = strlen(line);
 
 		/*
-		 * trim article body and sig (not verbatim blocks):
-		 * - skip leading blank lines
-		 * - replace multiple blank lines with one empty line
-		 * - skip tailing blank lines, keep one if an
-		 *   attachment follows
+		 * assume that yenc never shows up in encoded articles (cause then
+		 * MIME could have been used), lines are between 128 or 130 chars
+		 * (incl. '\n') and lines are not all ascii (unlikely for yenc).
+		 * we use raw_len as a flag.
 		 */
-		if (curr_group->attribute->trim_article_body && !in_uue && !in_verbatim && !verbatim_begin) {
-			len_blank = 1;
-			tmpline = line;
-			/* check if line contains only whitespace */
-			while ((*tmpline == ' ') || (*tmpline == '\t')) {
-				++len_blank;
-				++tmpline;
-			}
-			if (len_blank == len) {		/* line is blank */
-				if (lines_left == 0 && (curr_group->attribute->trim_article_body & SKIP_TRAILING)) {
-					if (!(part->next == NULL || (STRIP_ALTERNATIVE(art) && !IS_PLAINTEXT(part->next))))
-						put_cooked(1, TRUE, in_sig ? C_SIG : C_BODY, "\n");
-					continue;
-				}
-				if (first_line_blank) {
-					if (curr_group->attribute->trim_article_body & SKIP_LEADING)
+		if ((hide_inline_data & UUE_ALL) && section == TEXT_SECTION && (part->encoding == ENCODING_7BIT || part->encoding == ENCODING_8BIT) && !strcasecmp(charset, "US-ASCII") && (*raw_line != '=' || *(raw_line + 1) != 'y')) {
+			raw_len = strlen(raw_line);
+			/* skip check after 100 yenc-lins; yenc should run till ^=yend or EOF */
+			/* TODO: use defines instead of magic numbers */
+			if (lines_hidden <= 100 && (raw_len < 128 || raw_len > 130))
+				raw_len = 0;
+		} else
+			raw_len = 0;
+
+		/* look for verbatim marks, set in_verbatim only for lines in between */
+		if (curr_group->attribute->verbatim_handling > VERBATIM_NONE) {
+			if (section & VERBATIM_BEGIN) {
+				section &= ~VERBATIM_BEGIN;
+				section |= VERBATIM_SECTION;
+			} else {
+				if (section == TEXT_SECTION && MATCH_REGEX(verbatim_begin_regex, line, len))
+					section = VERBATIM_BEGIN;
+			}
+			if ((section & VERBATIM_SECTION) && MATCH_REGEX(verbatim_end_regex, line, len)) {
+				section &= ~VERBATIM_SECTION;
+				section |= VERBATIM_END;
+			}
+		} /* else section &= ~(VERBATIM_BEGIN | VERBATIM_SECTION | VERBATIM_END); */
+
+		if (!(section & VERBATIM_SECTION)) {
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+			/*
+			 * UTF-8 and all ISO-8859 charsets but ISO-8859-11 do have SHY at 0xAD
+			 * also KOI8-[ET] and Windows-125[0-8] do have SHY at 0xAD
+			 */
+			if (strcasecmp(tinrc.mm_local_charset, "ISO-8859-11") && (IS_LOCAL_CHARSET("ISO-8859") || IS_LOCAL_CHARSET("UTF-8")) && curr_group->attribute->suppress_soft_hyphens) {
+				remove_soft_hyphens(line);
+				len = strlen(line);
+			}
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+
+			/*
+			 * trim article body and sig (not verbatim blocks):
+			 * - skip leading blank lines
+			 * - replace multiple blank lines with one empty line
+			 * - skip tailing blank lines, keep one if an
+			 *   attachment follows
+			 */
+			if (curr_group->attribute->trim_article_body && !(section & (UUE_SECTION | YENC_SECTION))) {
+				/* skip all consecutive blanks */
+				for (cp = line; (*cp == ' ') || (*cp == '\t'); cp++)
+					;
+				if (*cp == '\n') {	/* line was all blank */
+					if (section & (SHAR_SECTION | PGP_ANY_SECTION)) {
+						++non_attach_lines;
 						continue;
-				} else if ((curr_group->attribute->trim_article_body & (COMPACT_MULTIPLE | SKIP_TRAILING)) && (!in_sig || curr_group->attribute->show_signatures)) {
-					++lines_skipped;
-					if (lines_left == 0 && !(curr_group->attribute->trim_article_body & SKIP_TRAILING)) {
-						for (; lines_skipped > 0; lines_skipped--)
-							put_cooked(1, TRUE, in_sig ? C_SIG : C_BODY, "\n");
 					}
-					continue;
-				}
-			} else {	/* line is not blank */
-				if (first_line_blank)
-					first_line_blank = FALSE;
-				if (lines_skipped && (!in_sig || curr_group->attribute->show_signatures)) {
-					if (strcmp(line, SIGDASHES) != 0 || curr_group->attribute->show_signatures) {
-						if (curr_group->attribute->trim_article_body & COMPACT_MULTIPLE)
-							put_cooked(1, TRUE, in_sig ? C_SIG : C_BODY, "\n");
-						else
+					if (lines_left == 0 && (curr_group->attribute->trim_article_body & SKIP_TRAILING)) {
+						if (!(part->next == NULL || (STRIP_ALTERNATIVE(art) && !IS_PLAINTEXT(part->next))))
+							put_cooked(1, TRUE, (section & SIGNATURE_SECTION) ? C_SIG : C_BODY, "\n");
+						continue;
+					}
+					if (first_line_blank) {
+						if (curr_group->attribute->trim_article_body & SKIP_LEADING)
+							continue;
+					} else if ((curr_group->attribute->trim_article_body & (COMPACT_MULTIPLE | SKIP_TRAILING)) && (!(section & SIGNATURE_SECTION) || curr_group->attribute->show_signatures)) {
+						++lines_skipped;
+						if (lines_left == 0 && !(curr_group->attribute->trim_article_body & SKIP_TRAILING)) {
+							for (; lines_skipped > 0; lines_skipped--)
+								put_cooked(1, TRUE, (section & SIGNATURE_SECTION) ? C_SIG : C_BODY, "\n");
+						}
+						continue;
+					}
+				} else {	/* line is not blank */
+					if (first_line_blank)
+						first_line_blank = FALSE;
+					if (lines_skipped && (!(section & SIGNATURE_SECTION) || curr_group->attribute->show_signatures)) {
+						if (strcmp(line, SIGDASHES) != 0 || curr_group->attribute->show_signatures) {
+							if (curr_group->attribute->trim_article_body & COMPACT_MULTIPLE)
+								put_cooked(1, TRUE, (section & SIGNATURE_SECTION) ? C_SIG : C_BODY, "\n");
+							else
+								put_blank_lines = TRUE;
+						} else if (!(curr_group->attribute->trim_article_body & SKIP_TRAILING))
 							put_blank_lines = TRUE;
-					} else if (!(curr_group->attribute->trim_article_body & SKIP_TRAILING))
-						put_blank_lines = TRUE;
-					if (put_blank_lines) {
-						for (; lines_skipped > 0; lines_skipped--)
-							put_cooked(1, TRUE, in_sig ? C_SIG : C_BODY, "\n");
+						if (put_blank_lines) {
+							for (; lines_skipped > 0; lines_skipped--)
+								put_cooked(1, TRUE, (section & SIGNATURE_SECTION) ? C_SIG : C_BODY, "\n");
+						}
+						put_blank_lines = FALSE;
+						lines_skipped = 0;
 					}
-					put_blank_lines = FALSE;
-					lines_skipped = 0;
 				}
-			}
-		} /* if (tinrc.trim_article_body...) */
-
-		/* look for verbatim marks, set in_verbatim only for lines in between */
-		if (curr_group->attribute->verbatim_handling) {
-			if (verbatim_begin) {
-				in_verbatim = TRUE;
-				verbatim_begin = FALSE;
-			} else if (!in_sig && !in_uue && !in_verbatim && MATCH_REGEX(verbatim_begin_regex, line, len))
-				verbatim_begin = TRUE;
-			if (in_verbatim && MATCH_REGEX(verbatim_end_regex, line, len))
-				in_verbatim = FALSE;
-		}
+			} /* if (tinrc.trim_article_body...) */
 
-		if (!in_verbatim) {
 			/*
 			 * Detect and skip signatures if necessary
 			 */
-			if (!in_sig) {
-				if (STRCMPEQ(line, SIGDASHES)) {
-					in_sig = TRUE;
-					if (in_uue) {
-						in_uue = FALSE;
-						if (hide_uue)
-							put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
-					}
+			if (!(section & SIGNATURE_SECTION) && STRCMPEQ(line, SIGDASHES)) {
+				section |= SIGNATURE_SECTION;
+				if (section & UUE_SECTION) {
+					section &= ~UUE_SECTION;
+					if (hide_inline_data & UUE_ALL)
+						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+				}
+				if (section & YENC_SECTION) {
+					section &= ~YENC_SECTION;
+					if (hide_inline_data & UUE_ALL)
+						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_YENC_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
 				}
 			}
 
-			if (in_sig && !(curr_group->attribute->show_signatures))
+			if ((section & SIGNATURE_SECTION) && !(curr_group->attribute->show_signatures))
 				continue;					/* No further processing needed */
 
 			/*
+			 * TODO:
+			 *       - convert single part yenc data into base64 encoded
+			 *         mime attachments on the fly? attachment level could
+			 *         make use of it...
+			 *       - do the same for shar parts
+			 *       - move strings to lang.c (and wrap into _()?)
+			 *       - we should use raw_line instead of line (but we
+			 *         abuse raw_len as a flag)
+			 */
+			if (!(section & (SIGNATURE_SECTION | UUE_SECTION | PGP_ANY_SECTION | SHAR_SECTION))) { /* yenc? */
+				if (*line == '=' && *(line + 1) == 'y') { /* can't show up in yenc-bodies */
+					if (MATCH_REGEX(yencbegin_regex, line, len)) {
+#	ifdef INLINE_DEBUG_MIME
+						if (section & YENC_SECTION) {
+							DEBUG_PUT_YENC_UNEXPECTED_ITEM("=ybegin");
+						} else
+#	endif /* INLINE_DEBUG_MIME */
+							section |= YENC_SECTION;
+
+						ncs = regex_get_substring_by_name(&yencbegin_regex, "y_bsize", line);
+						if (ncs && *ncs) {
+							y_bsize = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("size", ncs, "=ybegin");
+								y_bsize = 0;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("size", "=ybegin");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						/* part / total are optional */
+						ncs = regex_get_substring_by_name(&yencbegin_regex, "y_part", line);
+						if (ncs && *ncs) {
+							y_part = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("part", ncs, "=ybegin");
+								y_part = 0;
+							}
+						}
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencbegin_regex, "y_total", line);
+						if (ncs && *ncs) {
+							y_total = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("total", ncs, "=ybegin");
+								y_total = 0;
+							}
+						}
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencbegin_regex, "y_line", line);
+						if (ncs && *ncs) {
+#	ifdef INLINE_DEBUG_MIME
+							if (!strtol(ncs, &cp, 10) || cp == ncs || *ncs == '-')
+								DEBUG_PUT_YENC_INVALID_ITEM("line", ncs, "=ybegin");
+#	endif /* INLINE_DEBUG_MIME */
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("line", "=ybegin");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencbegin_regex, "y_name", line);
+						if (ncs && *ncs)
+							y_name = my_strdup(ncs);
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("name", "=ybegin");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						if (!y_name)
+							y_name = my_strdup(txt_unknown);
+
+						curruue = new_uue(&part, y_name);
+						curruue->encoding = ENCODING_YENC;
+						FreeAndNull(y_name);
+						y_ccrc = tin_crc32(0L, NULL, 0);
+					} else if (MATCH_REGEX(yencpart_regex, line, len)) {
+						ncs = regex_get_substring_by_name(&yencpart_regex, "y_pbegin", line);
+						if (ncs && *ncs) {
+							y_pbegin = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("begin", ncs, "=ypart");
+								y_pbegin = 0;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("begin", "=ypart");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencpart_regex, "y_pend", line);
+						if (ncs && *ncs) {
+							y_pend = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("end", ncs, "=ypart");
+								y_pend = 0;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("end", "=ypart");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						if (y_pbegin > y_pend)
+							y_pend = 0;
+						/* guess the # parts if no total= was found */
+						if (!y_total) {
+							if (y_pend && y_pend < y_bsize)
+								y_total = y_bsize / (y_pend - y_pbegin) + ((y_bsize % (y_pend - y_pbegin)) ? 1 : 0);
+							else
+								y_total = y_part;
+						}
+#	ifdef INLINE_DEBUG_MIME
+						if (!(section & YENC_SECTION))
+							DEBUG_PUT_YENC_UNEXPECTED_ITEM("=ypart");
+#	endif /* INLINE_DEBUG_MIME */
+					} else if (MATCH_REGEX(yencend_regex, line, len)) {
+						unsigned long y_ecrc = 0L; /* crc32 mentioned in end line */
+						unsigned long y_epcrc = 0L; /* pcrc32 mentioned in end line */
+
+						if (!(section & YENC_SECTION) && lines_hidden) {
+							put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], lines_hidden), _(txt_yenc_partial), lines_hidden);
+							lines_hidden = 0;
+						}
+
+						y_esize = 0L;
+						ncs = regex_get_substring_by_name(&yencend_regex, "y_esize", line);
+						if (ncs && *ncs) {
+							y_esize = strtol(ncs, &cp, 10);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("size", ncs, "=yend");
+								y_esize = 0;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else
+							DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("size", "=yend");
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencend_regex, "y_epcrc", line);
+						if (ncs && *ncs) {
+							y_epcrc = strtol(ncs, &cp, 16);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("pcrc32", ncs, "=yend");
+								y_epcrc = 0L;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else {
+							if (y_part)
+								DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("pcrc32", "=yend");
+						}
+#	endif /* INLINE_DEBUG_MIME */
+						FreeAndNull(ncs);
+
+						ncs = regex_get_substring_by_name(&yencend_regex, "y_ecrc", line);
+						if (ncs && *ncs) {
+							y_ecrc = strtol(ncs, &cp, 16);
+							if (cp == ncs || *ncs == '-') {
+								DEBUG_PUT_YENC_INVALID_ITEM("crc32", ncs, "=yend");
+								y_ecrc = 0L;
+							}
+						}
+#	ifdef INLINE_DEBUG_MIME
+						else {
+							if (y_part && y_part == y_total)
+								DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM("crc32", "=yend");
+						}
+#	endif /* INLINE_DEBUG_MIME */
+
+						FreeAndNull(ncs);
+						if (!(section & YENC_SECTION)) {
+							DEBUG_PUT_YENC_UNEXPECTED_ITEM("=yend");
+							if ((hide_inline_data & UUE_ALL))
+								continue;
+						} else {
+							enum section_type section_type;
+
+							section &= ~YENC_SECTION;
+							GET_YENC_SECTION_TYPE();
+							PUT_YENC_HEADER();
+#	if defined(INLINE_DEBUG_MIME)
+							/* as we don't have the full crc of multiparts we must compare against pcrc if set */
+							if (y_epcrc) {
+								if (y_ccrc != y_epcrc)
+									DEBUG_PUT_YENC_CRC32_MISMATCH((unsigned long) y_ccrc, y_epcrc);
+							} else {
+								if (y_ecrc && (y_ccrc != y_ecrc))
+									DEBUG_PUT_YENC_CRC32_MISMATCH((unsigned long) y_ccrc, y_ecrc);
+							}
+#	endif /* INLINE_DEBUG_MIME */
+							y_bsize = 0L;
+							y_total = y_part = 0;
+							continue;
+						}
+					}
+#	ifdef INLINE_DEBUG_MIME
+					else {
+						put_cooked(LEN, wrap_lines, C_YENC, "[-- Error: missing =yend --]");
+					}
+#	endif /* INLINE_DEBUG_MIME */
+				} else {
+					if (section & YENC_SECTION) {
+						unsigned char ch;
+						unsigned char *dl = my_calloc(strlen(raw_line), 1);
+						int cnt = 0;
+
+						cp = raw_line;
+						while (*cp) {
+							if (*cp == '\n' || *cp == '\r')
+								break;
+							if (*cp == '=') { /* escaped? */
+								++cp;
+								if (!*cp) /* unexpected EOL */
+									break;
+								else
+									ch = (*cp) - 64 - 42;
+							} else
+								ch = (*cp) - 42;
+							dl[cnt++] = ch;
+							++cp;
+						}
+						curruue->bytes += cnt;
+						curruue->line_count++;
+						dl[cnt] = '\0';
+						y_ccrc = tin_crc32(y_ccrc, dl, cnt);
+#if 0
+						if (hide_inline_data & UUE_ALL) {
+							cp = my_calloc((strlen(raw_line) + 1) * 4 / 3 + 1, 1);
+
+							/* process_charsets(&dl, &cnt, charset, tinrc.mm_local_charset, FALSE); */
+							put_cooked(LEN, wrap_lines, C_ATTACH, "%s", dl); /* decoded data */
+							str2b64((const char*) dl, cp);
+							put_cooked(LEN, wrap_lines, C_ATTACH, "%s", cp); /* quick hack, base64 encoded data, would need proper splitting for MIME */
+							free(cp);
+						}
+#endif /* 0 */
+						free(dl);
+					}
+				}
+				if ((section & YENC_SECTION) && (hide_inline_data & UUE_ALL))
+					continue;
+			}
+
+			/*
 			 * Detect and process uuencoded sections
 			 * Look for the start or the end of a uuencoded section
 			 *
@@ -1090,63 +1686,93 @@ process_text_body_part(
 			 *       do we want to cook uue-parts in signatures?
 			 */
 
-			is_uubegin = FALSE;
+			section &= ~UUE_BEGIN;
 
 			if (MATCH_REGEX(uubegin_regex, line, len)) {
 				REGEX_SIZE *ovector = regex_get_ovector_pointer(&uubegin_regex);
 
-				if (in_uue) { /* previous uue part incomplete and the current one follows without gap */
-					if (hide_uue)
-						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+				if (section & UUE_SECTION) { /* previous uue part incomplete and the current one follows without gap */
+					if (hide_inline_data & UUE_ALL)
+						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
 				} else
-					in_uue = TRUE;
+					section |= UUE_SECTION;
 
-				is_uubegin = TRUE;
-				curruue = new_uue(&part, line + ovector[1]);
-				if (hide_uue)
+				section |= UUE_BEGIN;
+				if (*(line + ovector[0] + 5) != '-')
+					curruue = new_uue(&part, line + ovector[1]);
+				else { /* must be "begin-encoded" */
+					cp = my_malloc(strlen(line + ovector[1]));
+
+					if (b642str(line + ovector[1], cp) == -1)
+						strcpy(cp, line + ovector[1]);
+					curruue = new_uue(&part, cp);
+					free(cp);
+				}
+				if (hide_inline_data & UUE_ALL)
 					continue;				/* Don't cook the 'begin' line */
 			} else if (STRNCMPEQ(line, "end\n", 4)) {
-				if (in_uue) {
-					in_uue = FALSE;
-					if (hide_uue) {
-						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, UUE_COMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+				if (section & UUE_SECTION) {
+					section &= ~UUE_SECTION;
+					if (hide_inline_data & UUE_ALL) {
+						put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_UUE_COMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
 						continue;			/* Don't cook the 'end' line */
 					}
 				}
 			}
 
 			/*
-			 * See if this line looks like a uuencoded 'body' line
+			 * See if this line looks like a uu-or xx-encoded 'body' line
 			 */
-			is_uubody = FALSE;
+			is_uubody = 0;
 
 			if (MATCH_REGEX(uubody_regex, line, len)) {
-				int sum = (((*line) - ' ') & 077) * 4 / 3;		/* uuencode octet checksum */
+				sum = (((*line) - ' ') & 077) * 4 / 3;		/* uuencode octet checksum */
+				/*
+				 * sum = 0 in a uubody only on the last line, a single `
+				 * +1 for the \n
+				 */
+				if ((sum == 0 && len == 1 + 1) || len == (unsigned) (sum + 1 + 1))
+					is_uubody = 1;
 
-				/* sum = 0 in a uubody only on the last line, a single ` */
-				if (sum == 0 && len == 1 + 1)			/* +1 for the \n */
-					is_uubody = TRUE;
-				else if (len == (unsigned) (sum + 1 + 1))
-					is_uubody = TRUE;
 #ifdef DEBUG_ART
 				if (debug & DEBUG_MISC)
-					fprintf(stderr, "%s sum=%d len=%lu (%s)\n", bool_unparse(is_uubody), sum, len, line);
+					fprintf(stderr, "%d sum=%d len=%lu %s", is_uubody, sum, len, line);
+#endif /* DEBUG_ART */
+			} else {
+				if (MATCH_REGEX(xxbody_regex, line, len)) {
+					/*
+					 * we don't bother to sum != 0x7f as it will be
+					 * caught be the check against len (limited via
+					 * the regex) anyway
+					 */
+					if (*line >= '+' && *line <= 'z' && (sum = xxenc[(*line - '+')]) >= 0) {
+						sum = sum * 4 / 3;
+						if ((sum == 0 && len == 1 + 1) || len == (unsigned) (sum + 1 + 1))
+							is_uubody = 2;
+					}
+#ifdef DEBUG_ART
+					else
+						sum = 0;
+
+					if (debug & DEBUG_MISC)
+						fprintf(stderr, "%d sum=%d len=%lu %s", is_uubody, sum, len, line);
 #endif /* DEBUG_ART */
+				}
 			}
 
-			if (in_uue) {
+			if (section & UUE_SECTION) {
 				if (is_uubody) {
 					curruue->line_count++;
 					curruue->bytes += len;
 				} else {
 					if (line[0] == '\n') {		/* Blank line in a uubody - definitely a failure */
 						/* fprintf(stderr, "not a uue line while reading a uue body?\n"); */
-						in_uue = FALSE;
-						if (hide_uue)
+						section &= ~UUE_SECTION;
+						if (hide_inline_data & UUE_ALL)
 							/* don't continue here, so we see the line that 'broke' in_uue */
-							put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+							put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
 					} else {
-						if (!is_uubegin) { /* xxencoding or the like */
+						if (!(section & UUE_BEGIN)) { /* xxencoding or the like */
 							curruue->line_count++;
 							curruue->bytes += len;
 						}
@@ -1154,18 +1780,22 @@ process_text_body_part(
 				}
 			} else {
 				/*
-				 * UUE_ALL = 'Try harder' - we never saw a begin line, but useful
+				 * UUE_ALLi = 'Try harder' - we never saw a begin line, but useful
 				 * when uue sections are split across > 1 article
+				 * requires at least one full uu/xx line to fire
 				 */
-				if (is_uubody && hide_uue == UUE_ALL) {
+				if (is_uubody && (hide_inline_data & UUE_ALL) && section == TEXT_SECTION && len == 62) {
 					/* _(txt_unknown) cannot be used directly in new_uue() due to str_trim() there */
 					char *name = my_strdup(_(txt_unknown));
 
-					in_uue = TRUE;
+					section |= UUE_SECTION;
 					curruue = new_uue(&part, name);
 					curruue->line_count++;
 					curruue->bytes += len;
 					free(name);
+#ifdef INLINE_DEBUG_MIME
+					put_cooked(LEN, wrap_lines, C_UUE, "[-- Error: unexpected %s --]", is_uubody == 1 ? "uu-encoced data" : "xx-encoced data");
+#endif /* INLINE_DEBUG_MIME */
 					continue;
 				}
 			}
@@ -1173,22 +1803,32 @@ process_text_body_part(
 			/*
 			 * Skip output if we're hiding uue or the sig
 			 */
-			if (in_uue && hide_uue)
+			if ((section & UUE_SECTION) && (hide_inline_data & UUE_ALL))
 				continue;	/* No further processing needed */
 		}
 
-		flags = in_verbatim ? C_VERBATIM : in_sig ? C_SIG : C_BODY;
+		flags = (section & VERBATIM_SECTION) ? C_VERBATIM : (section & SIGNATURE_SECTION) ? C_SIG : C_BODY;
 
 		/*
 		 * Don't do any further handling of uue || verbatim lines
 		 */
-		if (in_uue) {
+		if (section & (UUE_SECTION | YENC_SECTION)) {
 			put_cooked(max_line_len, wrap_lines, flags, "%s", line);
 			continue;
-		} else if (in_verbatim) {
-			expand_ctrl_chars(&line, &max_line_len, 8);
-			put_cooked(max_line_len, wrap_lines, flags, "%s", line);
+		} else if ((section & VERBATIM_BEGIN) && curr_group->attribute->verbatim_handling >= VERBATIM_HIDE_MARKS) {
+			if (curr_group->attribute->verbatim_handling == VERBATIM_HIDE_ALL)
+				put_cooked(strlen(_(txt_verbatim_block_hidden)), wrap_lines, C_VERBATIM, "%s", _(txt_verbatim_block_hidden));
+			continue;
+		} else if (section & VERBATIM_SECTION) {
+			if (curr_group->attribute->verbatim_handling < VERBATIM_HIDE_ALL) {
+				expand_ctrl_chars(&line, &max_line_len, 8);
+				put_cooked(max_line_len, wrap_lines, flags, "%s", line);
+			}
 			continue;
+		} else if (section & VERBATIM_END) {
+			section &= ~VERBATIM_END;
+			if (curr_group->attribute->verbatim_handling >= VERBATIM_HIDE_MARKS)
+				continue;
 		}
 
 #ifdef HAVE_COLOR
@@ -1214,19 +1854,19 @@ process_text_body_part(
 		}
 #endif /* HAVE_COLOR */
 
-#ifdef HAVE_LIBURIPARSER
+#if defined(HAVE_LIBURIPARSER) || defined(HAVE_LIBCURL)
 		/* find and validate URIs */
 		CHECK_URI(url_regex, C_URL);
 		CHECK_URI(mail_regex, C_MAIL);
-		CHECK_URI(news_regex, C_NEWS);
 #else
 		if (MATCH_REGEX(url_regex, line, len))
 			flags |= C_URL;
 		if (MATCH_REGEX(mail_regex, line, len))
 			flags |= C_MAIL;
+#endif /* HAVE_LIBURIPARSER */
+		/* see debian bug #687198 */
 		if (MATCH_REGEX(news_regex, line, len))
 			flags |= C_NEWS;
-#endif /* HAVE_LIBURIPARSER */
 
 		if (expand_ctrl_chars(&line, &max_line_len, tabwidth))
 			flags |= C_CTRLL;				/* Line contains form-feed */
